/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


#include <libc.h>
#include <string.h>
#include <stdio.h>

#include "OO7.hxx"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"

//////////////////////////////////////////////////////////////////
//
// Query #8 --- value join between Documents and AtomicParts
// on Document.id and AtomicPart.docId.  This is a key - foreign
// key join.
//
// The main drawback is that we have no semantics whatsoever for
// this query.
//
//////////////////////////////////////////////////////////////////

extern int	debugMode;

extern void JoinDoNothing(int x, int y);


//////////////////////////////////////////////////////////////////
//
// Routine to do Query #8
//
//////////////////////////////////////////////////////////////////


int query8()
{
    int count = 0;
    
    Iterator<AtomicPart> iter(*AtomicPart::extent_id) ;
    for (; iter.more(); iter.next()) {
      AtomicPart* ap = iter.get() ;

      if (debugMode) {
	printf("    In Query8, processing atomic part %d.\n", ap->id);
      }

      Document* doc = Document::extent->getFirst(ap->id) ;
      if (doc != NULL) {
	if (debugMode) {
	  printf("In Query8, atomic part %d matches doc %d.\n",
		 ap->id, doc->id);
	}
	
	JoinDoNothing(ap->id, doc->id);
	count++;
      }
    }

    return count;
}

